// This may look like C code, but it is really -*- C++ -*-
/*
 ************************************************************************
 *	Reliable Broadcast over unreliable low-bandwidth (satellite)
 *			channels with no feedback
 *
 * 			CRC calculation stuff
 *
 *
 * $Id: crc.h,v 1.1 1996/07/24 19:52:08 oleg Exp oleg $
 *
 ************************************************************************
 */

#ifndef __GNUC__
#pragma once
#else
#pragma interface
#endif

#ifndef __crc_h
#define __crc_h

class LAPIn;
class LAPOut;

class CRC16
{
  unsigned short curr_crc;

  static unsigned short crctab[];

public:
  CRC16(void) : curr_crc(0) {}
  
  		// Update the CRC for the character c
  inline unsigned short operator << (const unsigned char c)
  { return curr_crc = crctab[(unsigned char)(curr_crc >> 8)] ^ (curr_crc << 8) ^ c; }

  //?  operator unsigned short (void) const { return curr_crc; }
  friend LAPOut& operator << (LAPOut& lap, const CRC16 crc);
  CRC16(LAPIn& lap);

  bool operator == (CRC16 another_crc) const
  		{ return curr_crc == another_crc.curr_crc; }
  operator const char * (void) const;
};
#endif
